//-----------------------------------------------------------------------------
// File: PP_ColorUpFilter.fx
//
// Desc: Effect file for image post-processing sample.  This effect contains
//       a single technique with a pixel shader that scales images up 4
//       times.
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------

sampler g_samSrcColor   : register( s0 ) ;

//-----------------------------------------------------------------------------
// Pixel Shader: UpFilterPS
// Desc: Performs upfiltering to scale the image to the original size.
//-----------------------------------------------------------------------------
float4 UpFilterPS( float2 Tex : TEXCOORD0 ) : COLOR0
{
    return tex2D( g_samSrcColor, Tex );
}
