#include "DxLib.h"

// ʃTCY
#define SCREEN_W		640
#define SCREEN_H		480

// ʃeNX`TCY
#define SCREEN_TEXTURE_W		1024
#define SCREEN_TEXTURE_H		512

// |XgGtFNg̐
#define POSTEFFECT_NUM		2

// ʂɕ`悷摜̃nh
int GraphHandle ;

// sNZVF[_[nh
int ColorBloomHPS ;	// u[GtFNgp̃KEVAڂ(  ){Px̃sNZVF[_[
int ColorBloomVPS ;	// u[GtFNgp̃KEVAڂ(  ){Px̃sNZVF[_[
int ColorBrightPassPS ;	// ̖邳ȉ̕߂̃sNZVF[_[
int ColorDownFilter4PS ;	// 摜TCYYɂŜPɂ邽߂̃sNZVF[_[
int ColorUpFilter4PS ;	// 摜TCYS{ɂۂɎgpsNZVF[_[
int ColorCombine4PS ;	// 摜TCYS{ɂȂ烁Cʂƍ邽߂̃sNZVF[_[
int ColorGBlurHPS ;	// u[GtFNgp̃KEVAڂ(  )̃sNZVF[_[
int ColorGBlurVPS ;	// u[GtFNgp̃KEVAڂ(  )̃sNZVF[_[

// ʃOtBbNnh
int MainScreenGraph ;	// C̕`ƂĎgpnh
int WorkScreenGraph[ 2 ] ;	// |XgGtFNg̍ƗpɎgpnh
int TargetScreen ;	// `挋ʂi[ WorkScreenGraph z̗vfԍ
int SourceScreen ;	// `挳ƂȂ WorkScreenGraph z̗vfԍ( -1 ̏ꍇ MainScreenGraph gp )

// |S`p̒_f[^
VERTEX2DSHADER Vert[ 4 ] ;

// `挳p̃eNX`W
float TexCoordW, TexCoordH ;

// sNZVF[_[g|S̕`Ƃɕt鏈s֐
void RenderProcess( int PixelShader )
{
	// `Zbg
	SetDrawScreen( WorkScreenGraph[ TargetScreen ] ) ;

	// gpeNX`OԂɃZbg
	// ( SourceScreen }CiX̒lꍇ̓C̕`pXN[gp )
	SetUseTextureToShader( 0, SourceScreen < 0 ? MainScreenGraph : WorkScreenGraph[ SourceScreen ] ) ;

	// C̕`pXN[PԂɃZbg
	SetUseTextureToShader( 1, MainScreenGraph ) ;

	// ʂNA
	ClearDrawScreen() ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShader ) ;

	// `
	DrawPrimitive2DToShader( Vert, 4, DX_PRIMTYPE_TRIANGLESTRIP ) ;

	// ``挳̕ύX
	TargetScreen = TargetScreen != 0 ? 0 : 1 ;
	SourceScreen = SourceScreen != 0 ? 0 : 1 ;
}

// w̒萔z̃eNX`TCYŊĂsNZVF[_[萔ɃZbg֐
void SetupTexCoordConst( const char *ConstArrayName, int PixelShader )
{
	const FLOAT4 *DefaultParam ;
	FLOAT4 ConstParam ;
	int ConstIndex ;
	int ConstCount ;
	int i ;

	// 萔zftHgli[ĂAhX擾
	DefaultParam = GetConstDefaultParamFToShader( ConstArrayName, PixelShader ) ;

	// 萔z񂪎gpVF[_[萔̔ԍ擾
	ConstIndex = GetConstIndexToShader( ConstArrayName, PixelShader ) ;

	// 萔z񂪎gpVF[_[萔̐擾
	ConstCount = GetConstCountToShader( ConstArrayName, PixelShader ) ;

	// 萔Zbg
	for( i = 0 ; i < ConstCount ; i ++ )
	{
		// XChlsNZWPʂeNX`WPʂɕϊ
		ConstParam.x = DefaultParam[ i ].x / SCREEN_TEXTURE_W ;
		ConstParam.y = DefaultParam[ i ].y / SCREEN_TEXTURE_H ;
		ConstParam.z = 0.0f ;
		ConstParam.w = 0.0f ;

		// 萔Zbg
		SetPSConstF( ConstIndex + i, ConstParam ) ;
	}
}

// eNX`W̍XV
void UpdateTexCoord( float Scale )
{
	// eNX`W̃XP[O
	TexCoordW *= Scale ;
	TexCoordH *= Scale ;

	// eNX`Wɔf
	Vert[ 1 ].u = Vert[ 3 ].u = TexCoordW ;
	Vert[ 2 ].v = Vert[ 3 ].v = TexCoordH ;
}

// _W̍XV
void UpdatePosition( float Scale )
{
	// _W̃XP[O
	Vert[ 1 ].pos.x = ( Vert[ 1 ].pos.x + 0.5f ) * Scale - 0.5f ;
	Vert[ 3 ].pos.x = ( Vert[ 3 ].pos.x + 0.5f ) * Scale - 0.5f ;
	Vert[ 2 ].pos.y = ( Vert[ 2 ].pos.y + 0.5f ) * Scale - 0.5f ;
	Vert[ 3 ].pos.y = ( Vert[ 3 ].pos.y + 0.5f ) * Scale - 0.5f ;
}

// u[tB^[( pXOA )
void BloomHorizontal( float BloomScaleParam )
{
	SetupTexCoordConst( "PixelKernel", ColorBloomHPS ) ;	// eNX`WɊ֌W萔z̃ZbgAbv
	SetPSConstSF( GetConstIndexToShader( "BloomScale", ColorBloomHPS ), BloomScaleParam ) ;	// BloomScale 萔̃Zbg
	RenderProcess( ColorBloomHPS ) ;	// |S`
}

// u[tB^[( pXPA )
void BloomVertical( float BloomScaleParam )
{
	SetupTexCoordConst( "PixelKernel", ColorBloomVPS ) ;	// eNX`WɊ֌W萔z̃ZbgAbv
	SetPSConstSF( GetConstIndexToShader( "BloomScale", ColorBloomVPS ), BloomScaleParam ) ;	// BloomScale 萔̃Zbg
	RenderProcess( ColorBloomVPS ) ;	// |S`
}

// 邢̂ݎctB^[
void BrightPass( void )
{
	RenderProcess( ColorBrightPassPS ) ;	// |S`
}

// 摜̃TCYYɂŜPɂtB^[
void DownFilter4x( void )
{
	float Scale = 0.25f ;
	UpdatePosition( Scale ) ;	// _f[^̃XP[O
	SetupTexCoordConst( "PixelCoordsDownFilter", ColorDownFilter4PS ) ;	// eNX`WɊ֌W萔z̃ZbgAbv
	RenderProcess( ColorDownFilter4PS ) ;	// |S`
	UpdateTexCoord( Scale ) ;	// eNX`W̍XV
}

// S{gtB^[
void UpFilter4x( void )
{
	float Scale = 4.0f ;
	UpdatePosition( Scale ) ;	// _f[^̃XP[O
	RenderProcess( ColorUpFilter4PS ) ;	// |S`
	UpdateTexCoord( Scale ) ;	// eNX`W̍XV
}

// S{g債Ȃ烁C̉ʂƍtB^[
void Combine4x( void )
{
	float Scale = 4.0f ;
	UpdatePosition( Scale ) ;	// _f[^̃XP[O
	RenderProcess( ColorCombine4PS ) ;	// |S`
	UpdateTexCoord( Scale ) ;	// eNX`W̍XV
}

// u[tB^[( pXOA )
void GaussianBlurHorizontal( void )
{
	SetupTexCoordConst( "PixelKernel", ColorGBlurHPS ) ;	// eNX`WɊ֌W萔z̃ZbgAbv
	RenderProcess( ColorGBlurHPS ) ;	// |S`
}

// u[tB^[( pXPA )
void GaussianBlurVertical( void )
{
	SetupTexCoordConst( "PixelKernel", ColorGBlurVPS ) ;	// eNX`WɊ֌W萔z̃ZbgAbv
	RenderProcess( ColorGBlurVPS ) ;	// |S`
}

// WinMain
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int PostEffectIndex ;
	const char *PostEffectName[] = { "u[GtFNg", "u[GtFNg" } ;
	int DisplayFPS ;
	int FPSCount ;
	LONGLONG StartTime ;
	LONGLONG NowTime ;
	float BloomScaleParam ;

	// EChE[hŋN
	ChangeWindowMode( TRUE );

	// ʃ[h̐ݒ
	SetGraphMode( SCREEN_W, SCREEN_H, 32 ) ;

	// urxmb҂Ȃ
	SetWaitVSyncFlag( FALSE ) ;

	// EChEeLXgύX
	SetWindowText( "PostEffectTest" ) ;

	// cwCȕ
	if( DxLib_Init() < 0 ) return -1;

	// 摜̓ǂݍ
	GraphHandle = LoadGraph( "Test1.bmp" );

	// sNZVF[_[oCiR[h̓ǂݍ
	ColorBloomHPS = LoadPixelShader( "PP_ColorBloomH.pso" ) ;
	ColorBloomVPS = LoadPixelShader( "PP_ColorBloomV.pso" ) ;
	ColorBrightPassPS = LoadPixelShader( "PP_ColorBrightPass.pso" ) ;
	ColorDownFilter4PS = LoadPixelShader( "PP_ColorDownFilter4.pso" ) ;
	ColorUpFilter4PS = LoadPixelShader( "PP_ColorUpFilter4.pso" ) ;
	ColorCombine4PS = LoadPixelShader( "PP_ColorCombine4.pso" ) ;
	ColorGBlurHPS = LoadPixelShader( "PP_ColorGBlurH.pso" ) ;
	ColorGBlurVPS = LoadPixelShader( "PP_ColorGBlurV.pso" ) ;

	// `p̃XN[쐬
	MainScreenGraph = MakeScreen( SCREEN_TEXTURE_W, SCREEN_TEXTURE_H ) ;	// C̕`p̃XN[̍쐬
	WorkScreenGraph[ 0 ] = MakeScreen( SCREEN_TEXTURE_W, SCREEN_TEXTURE_H ) ;	// ƗpʂpӂĂ
	WorkScreenGraph[ 1 ] = MakeScreen( SCREEN_TEXTURE_W, SCREEN_TEXTURE_H ) ;

	// \[h̓u[ɂĂ
	PostEffectIndex = 0 ;

	// u[̋Px␳l̒l
	BloomScaleParam = 1.5f ;

	// t[[g\֌W̏
	StartTime = GetNowHiPerformanceCount() ;
	DisplayFPS = 0 ;
	FPSCount = 0 ;

	// C[v
	while( ProcessMessage() == 0 )
	{
		// L[͑
		switch( GetInputChar( TRUE ) )
		{
		case CTRL_CODE_UP :
			PostEffectIndex ++ ;
			if( PostEffectIndex == POSTEFFECT_NUM )
			{
				PostEffectIndex = 0 ;
			}
			break ;

		case CTRL_CODE_DOWN :
			PostEffectIndex -- ;
			if( PostEffectIndex < 0 )
			{
				PostEffectIndex = POSTEFFECT_NUM - 1 ;
			}
			break ;

		case CTRL_CODE_LEFT :
			BloomScaleParam -= 0.1f ;
			break ;

		case CTRL_CODE_RIGHT :
			BloomScaleParam += 0.1f ;
			break ;
		}

		// C̕`pXN[`ɕύX
		SetDrawScreen( MainScreenGraph ) ;

		// ʂ̏
		ClearDrawScreen() ;

		// Fۂ`
		DrawCircle( 200, 240, 128, GetColor( 255,255,0 ), TRUE ) ;

		// 摜`
		DrawGraph( 400, 0, GraphHandle, TRUE ) ;

		// eNX`W
		TexCoordW = ( float )SCREEN_W / SCREEN_TEXTURE_W ;
		TexCoordH = ( float )SCREEN_H / SCREEN_TEXTURE_H ;

		// _f[^̏
		Vert[ 0 ].pos = VGet(          - 0.5f,          - 0.5f, 0.0f ) ;
		Vert[ 1 ].pos = VGet( SCREEN_W - 0.5f,          - 0.5f, 0.0f ) ;
		Vert[ 2 ].pos = VGet(          - 0.5f, SCREEN_H - 0.5f, 0.0f ) ;
		Vert[ 3 ].pos = VGet( SCREEN_W - 0.5f, SCREEN_H - 0.5f, 0.0f ) ;
		Vert[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
		Vert[ 0 ].spc = GetColorU8( 0,0,0,0 ) ;
		Vert[ 0 ].u = 0.0f ;      Vert[ 0 ].v = 0.0f ;
		Vert[ 1 ].u = TexCoordW ; Vert[ 1 ].v = 0.0f ;
		Vert[ 2 ].u = 0.0f ;      Vert[ 2 ].v = TexCoordH ;
		Vert[ 3 ].u = TexCoordW ; Vert[ 3 ].v = TexCoordH ;
		Vert[ 0 ].su = 0.0f ;      Vert[ 0 ].sv = 0.0f ;
		Vert[ 1 ].su = TexCoordW ; Vert[ 1 ].sv = 0.0f ;
		Vert[ 2 ].su = 0.0f ;      Vert[ 2 ].sv = TexCoordH ;
		Vert[ 3 ].su = TexCoordW ; Vert[ 3 ].sv = TexCoordH ;
		Vert[ 0 ].rhw = 1.0f ;
		Vert[ 1 ].rhw = 1.0f ;
		Vert[ 2 ].rhw = 1.0f ;
		Vert[ 3 ].rhw = 1.0f ;

		// oCjAԕ`
		SetDrawMode( DX_DRAWMODE_BILINEAR ) ;

		// `ʂ̏ƕ`挳ʂ̏
		TargetScreen = 0 ;
		SourceScreen = -1 ;

		// `惂[hɂď𕪊
		switch( PostEffectIndex )
		{
		case 0 :
			// u[|XgGtFNg
			DownFilter4x() ;						// ʉ摜ŜPɂ
			DownFilter4x() ;						// XɂŜPō킹ĂPÛP
			BrightPass() ;							// 邢c
			BloomHorizontal( BloomScaleParam ) ;	// ɂڂȂ኱邭
			BloomVertical( BloomScaleParam ) ;		// cɂڂȂ኱邭
			BloomHorizontal( BloomScaleParam ) ;	// čXɂڂ{邭A
			BloomVertical( BloomScaleParam ) ;		// c
			UpFilter4x() ;							// S{g
			Combine4x() ;							// XɂS{g傷ƓɃC̕`pXN[ƍ
			break ;

		case 1 :
			// u[|XgGtFNg
			DownFilter4x() ;			// ʉ摜ŜPɂ
			GaussianBlurHorizontal() ;	// ɂڂ
			GaussianBlurVertical() ;	// cɂڂ
			GaussianBlurHorizontal() ;	// čXɂڂA
			GaussianBlurVertical() ;	// c
			UpFilter4x() ;				// S{g
			break ;
		}

		// `𗠉ʂɕύX
		SetDrawScreen( DX_SCREEN_BACK ) ;

		// ɕ`挳ɂȂ͂Ɖʂʂɕ`
		DrawGraph( 0, 0, WorkScreenGraph[ SourceScreen ], FALSE ) ;

		// [h`
		DrawFormatString( 0, 0, GetColor( 255,255,255 ), "%s", PostEffectName[ PostEffectIndex ] ) ;

		// FPS`
		DrawFormatString( 0, 16, GetColor( 255,255,255 ), "FPS:%d", DisplayFPS ) ;

		// u[GtFNg̋Pxp[^`
		DrawFormatString( 0, 40, GetColor( 255,255,255 ), "BloomScaleParam:%.1f", BloomScaleParam ) ;

		// `
		DrawString( 0, 64, "㉺L[Ń|XgGtFNg؂ւ܂", GetColor( 255,255,255 ) ) ;
		DrawString( 0, 80, "EL[Ńu[GtFNg̋Pxp[^ύX܂", GetColor( 255,255,255 ) ) ;

		// ʂ̓e\ʂɕύX
		ScreenFlip() ;

		// t[[g
		FPSCount ++ ;
		NowTime = GetNowHiPerformanceCount() ;
		if( NowTime - StartTime > 1000000 )
		{
			DisplayFPS = FPSCount ;
			FPSCount = 0 ;
			StartTime = NowTime ;
		}
	}

	// cwCǔn
	DxLib_End();

	// \tg̏I
	return 0;
}
